/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-dec-err.c,v 1.2 2005/02/23 00:45:15 ca Exp $")

#include <stdio.h>

#include "sm/error.h"
#include "sm/dns.h"
#include "sm/bdb.h"
#include "sm/rfc2821.h"
#include "sm/test.h"

static void
errtxt(void)
{
	sm_ret_T err;
	char *errtxt;

	err = sm_error_perm(SM_EM_BDB, DB_KEYEMPTY);
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "DB_KEYEMPTY") == 0);

	err = sm_err_perm(R2821_ERR_DOMAIN);
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "domain part is empty") == 0);

	err = sm_err_perm(SM_E_NOMORE);
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "SM_E_NOMORE") == 0);

	err = sm_err_perm(DNSR_NOTFOUND);
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "DNSR Not Found") == 0);

	err = sm_err_perm(SM_CNF_E_CHAR_OVERFLOW);
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "character constant too large") == 0);

/*

	err = sm_err_perm();
	errtxt = smerr2txt(err);
	SM_TEST(strcmp(errtxt, "") == 0);
*/
}

int
main(int argc, char *argv[])
{
	sm_test_begin(argc, argv, "test dec-err");
	errtxt();
	return sm_test_end();
}
