/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: smbatvgetkey.c,v 1.2 2005/01/31 21:25:56 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/time.h"
#include "sm/batv.h"
#include "sm/batvcnf.h"

#if SM_USE_BATV
/*
**  SM_BATV_GETKEY -- find a key in a BATV configuration
**
**	Parameters:
**		key -- BATV key to use
**		batv_cnf -- BATV configuration
**		pbatv_key -- (pointer to) BATV key data (output)
**
**	Returns:
**		usual return code
*/

sm_ret_T
sm_batv_getkey(uint key, batv_cnf_P batv_cnf, batv_key_P *pbatv_key)
{
	uint i;

	SM_REQUIRE(batv_cnf != NULL);
	SM_REQUIRE(pbatv_key != NULL);

	/* search for key number */
	*pbatv_key = NULL;
	for (i = 0; i < batv_cnf->batvcnf_n; i++)
	{
		if (batv_cnf->batvcnf_keys[i].batv_key_number == key)
		{
			*pbatv_key = &(batv_cnf->batvcnf_keys[i]);
			return SM_SUCCESS;
		}
	}
	return sm_error_perm(SM_EM_BATV, SM_E_NOTFOUND);
}
#endif /* SM_USE_BATV */
