#!/bin/sh
# $Id: t-port-0.sh,v 1.5 2005/05/31 21:11:21 ca Exp $
# Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ------------------------------------------------------------
# Description:
# simple mailertable routing tests including port numbers
# by contacting SMAR
# uses t-smar-1 and startsmar.sh
# ------------------------------------------------------------
#
test -s stop && exit 1
#

# path to programs
P=..
SD=`dirname $0`
SHELL=/bin/sh
OUT=port-0.out
IP=port-0.ip
OK=port-0.ok
SOCK=qmsmar/qmsmar
PIDS=pids
ERRS=0
TPRG=./t-smar-1
rm -f ${SOCK} ${PIDS}

# prepare mailertable
cat > mt <<EOF
local.dom	lmtp:
port100.dom	100^[10.1.2.100]
port400.dom	400^[10.1.2.4]
port200.dom	200^esmtp:[10.1.2.200]
port3000.dom	3000^esmtp:[10.1.2.3]
EOF

# start SMAR
${SD}/startsmar.sh || exit 1

rm -f ${OUT} ${IP} ${OK}

# ----------------------------------------
${VALGRIND} ${TPRG} -M -VVVV '<t1@port100.dom>' > ${OUT} 2>&1
egrep '^(IP|port)' ${OUT} | sort > ${IP}
cat > ${OK} <<EOF
IP[0]=10.1.2.100 [a010264]
port=100
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
fi

# ----------------------------------------
${VALGRIND} ${TPRG} -M -VVVV '<t2@port400.dom>' > ${OUT} 2>&1
egrep '^(IP|port)' ${OUT} | sort > ${IP}
cat > ${OK} <<EOF
IP[0]=10.1.2.4 [a010204]
port=400
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
fi

# ----------------------------------------
${VALGRIND} ${TPRG} -M -VVVV '<t3@port200.dom>' > ${OUT} 2>&1
egrep '^(IP|port)' ${OUT} | sort > ${IP}
cat > ${OK} <<EOF
IP[0]=10.1.2.200 [a0102c8]
port=200
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
fi

# ----------------------------------------
${VALGRIND} ${TPRG} -M -VVVV '<t4@port3000.dom>' > ${OUT} 2>&1
egrep '^(IP|port)' ${OUT} | sort > ${IP}
cat > ${OK} <<EOF
IP[0]=10.1.2.3 [a010203]
port=3000
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
fi

rm -f ${OUT} ${IP} ${OK}

# stop SMAR
for i in `cat ${PIDS}`
do
  kill ${i}
done
# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi

exit ${ERRS}
